# Python module
# Common functions

# Copyright (c) 2005-2007 Red Hat
#
#    Koji is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; 
#    version 2.1 of the License.
#
#    This software is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this software; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
#
# Authors:
#       Mike McLean <mikem@redhat.com>
#       Chris O'Brien <cobrien@redhat.com>

from koji import *
import koji as __koji
import sys

BREWDIR = '/mnt/brew'


# This bit of indirection is to support code that changes brew.BREWDIR
# We replace koji.BASEDIR with this indirect string object that looks
# up the value of BREWDIR.
class __IndirectString(object):
    def __init__(self, obj, prop):
        str.__init__(self)
        self._ind_o = obj
        self._ind_p = prop
    def __str__(i):
        return str(getattr(i._ind_o, i._ind_p))
    def __repr__(i):
        return repr(getattr(i._ind_o, i._ind_p))

_brewkoji_magic = 'BREWKOJI-9ad75b43cc884bd'
def __get_self():
    """Hack - search the module table for ourself"""
    for v in sys.modules.values():
        try:
            # 'is' is appropriate here
            if v._brewkoji_magic is _brewkoji_magic:
                return v
        except AttributeError:
            pass
    return None

__koji.BASEDIR = __IndirectString(__get_self(), 'BREWDIR')
BASEDIR = __koji.BASEDIR

#Exceptions whose names differ
BrewError = GenericError
BrewAuthError = AuthError
BrewNotAllowed = ActionNotAllowed
BrewAuthLockError = AuthLockError
BrewAuthExpired = AuthExpired
BrewSequenceError = SequenceError
BrewRetryError = RetryError
BrewDeprecated = FunctionDeprecated




# XXX - do we need to wrap ClientSession ??






